diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-socket-base.cc ns-3.33/src/internet/model/tcp-socket-base.cc
--- ns-3.32/src/internet/model/tcp-socket-base.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/tcp-socket-base.cc	2021-01-09 10:19:22.000000000 -0800
@@ -133,6 +133,11 @@
                    PointerValue (),
                    MakePointerAccessor (&TcpSocketBase::GetRxBuffer),
                    MakePointerChecker<TcpRxBuffer> ())
+    .AddAttribute ("CongestionOps",
+                   "Pointer to TcpCongestionOps object",
+                   PointerValue (),
+                   MakePointerAccessor (&TcpSocketBase::m_congestionControl),
+                   MakePointerChecker<TcpCongestionOps> ())
     .AddAttribute ("ReTxThreshold", "Threshold for fast retransmit",
                    UintegerValue (3),
                    MakeUintegerAccessor (&TcpSocketBase::SetRetxThresh,
@@ -1563,6 +1568,35 @@
     }
 }
 
+// Sender should reduce the Congestion Window as a response to receiver's
+// ECN Echo notification only once per window
+void
+TcpSocketBase::EnterCwr (uint32_t currentDelivered)
+{
+  NS_LOG_FUNCTION (this << currentDelivered);
+  m_tcb->m_ssThresh = m_congestionControl->GetSsThresh (m_tcb, BytesInFlight ());
+  NS_LOG_DEBUG ("Reduce ssThresh to " << m_tcb->m_ssThresh);
+  // Do not update m_cWnd, under assumption that recovery process will
+  // gradually bring it down to m_ssThresh.  Update the 'inflated' value of
+  // cWnd used for tracing, however.
+  m_tcb->m_cWndInfl = m_tcb->m_ssThresh;
+  NS_ASSERT (m_tcb->m_congState != TcpSocketState::CA_CWR);
+  NS_LOG_DEBUG (TcpSocketState::TcpCongStateName[m_tcb->m_congState] << " -> CA_CWR");
+  m_tcb->m_congState = TcpSocketState::CA_CWR;
+  // CWR state will be exited when the ack exceeds the m_recover variable.
+  // Do not set m_recoverActive (which applies to a loss-based recovery)
+  // m_recover corresponds to Linux tp->high_seq
+  m_recover = m_tcb->m_highTxMark;
+  if (!m_congestionControl->HasCongControl ())
+    {
+      // If there is a recovery algorithm, invoke it.
+      m_recoveryOps->EnterRecovery (m_tcb, m_dupAckCount, UnAckDataCount (), currentDelivered);
+      NS_LOG_INFO ("Enter CWR recovery mode; set cwnd to " << m_tcb->m_cWnd
+                    << ", ssthresh to " << m_tcb->m_ssThresh
+                    << ", recover to " << m_recover);
+    }
+}
+
 void
 TcpSocketBase::EnterRecovery (uint32_t currentDelivered)
 {
@@ -1736,6 +1770,9 @@
   NS_ASSERT (0 != (tcpHeader.GetFlags () & TcpHeader::ACK));
   NS_ASSERT (m_tcb->m_segmentSize > 0);
 
+  uint32_t previousLost = m_txBuffer->GetLost ();
+  uint32_t priorInFlight = m_tcb->m_bytesInFlight.Get ();
+
   // RFC 6675, Section 5, 1st paragraph:
   // Upon the receipt of any ACK containing SACK information, the
   // scoreboard MUST be updated via the Update () routine (done in ReadOptions)
@@ -1775,6 +1812,20 @@
 
   uint32_t currentDelivered = static_cast<uint32_t> (m_rateOps->GetConnectionRate ().m_delivered - previousDelivered);
 
+  if (m_tcb->m_congState == TcpSocketState::CA_CWR && (ackNumber > m_recover))
+    {
+      // Recovery is over after the window exceeds m_recover
+      // (although it may be re-entered below if ECE is still set)
+      NS_LOG_DEBUG (TcpSocketState::TcpCongStateName[m_tcb->m_congState] << " -> CA_OPEN");
+      m_tcb->m_congState = TcpSocketState::CA_OPEN;
+      if (!m_congestionControl->HasCongControl ())
+        {
+           m_tcb->m_cWnd = m_tcb->m_ssThresh.Get ();
+           m_recoveryOps->ExitRecovery (m_tcb);
+           m_congestionControl->CwndEvent (m_tcb, TcpSocketState::CA_EVENT_COMPLETE_CWR);
+        }
+    }
+
   if (ackNumber > oldHeadSequence && (m_tcb->m_ecnState != TcpSocketState::ECN_DISABLED) && (tcpHeader.GetFlags () & TcpHeader::ECE))
     {
       if (m_ecnEchoSeq < ackNumber)
@@ -1783,6 +1834,10 @@
           m_ecnEchoSeq = ackNumber;
           NS_LOG_DEBUG (TcpSocketState::EcnStateName[m_tcb->m_ecnState] << " -> ECN_ECE_RCVD");
           m_tcb->m_ecnState = TcpSocketState::ECN_ECE_RCVD;
+          if (m_tcb->m_congState != TcpSocketState::CA_CWR)
+            {
+              EnterCwr (currentDelivered);
+            }
         }
     }
   else if (m_tcb->m_ecnState == TcpSocketState::ECN_ECE_RCVD && !(tcpHeader.GetFlags () & TcpHeader::ECE))
@@ -1801,8 +1856,6 @@
 
   if (m_congestionControl->HasCongControl ())
     {
-      uint32_t previousLost = m_txBuffer->GetLost ();
-      uint32_t priorInFlight = m_tcb->m_bytesInFlight.Get ();
       uint32_t currentLost = m_txBuffer->GetLost ();
       uint32_t lost = (currentLost > previousLost) ?
             currentLost - previousLost :
@@ -2001,6 +2054,17 @@
             }
           NewAck (ackNumber, true);
         }
+      else if (m_tcb->m_congState == TcpSocketState::CA_CWR)
+        {
+          m_congestionControl->PktsAcked (m_tcb, segsAcked, m_tcb->m_lastRtt);
+          // TODO: need to check behavior if marking is compounded by loss
+          // and/or packet reordering
+          if (!m_congestionControl->HasCongControl () && segsAcked >= 1)
+            {
+              m_recoveryOps->DoRecovery (m_tcb, currentDelivered);
+            }
+          NewAck (ackNumber, true);
+        }
       else
         {
           if (m_tcb->m_congState == TcpSocketState::CA_OPEN)
@@ -2085,6 +2149,7 @@
           if (exitedFastRecovery)
             {
               NewAck (ackNumber, true);
+              m_tcb->m_cWnd = m_tcb->m_ssThresh.Get ();
               m_recoveryOps->ExitRecovery (m_tcb);
               NS_LOG_DEBUG ("Leaving Fast Recovery; BytesInFlight() = " <<
                             BytesInFlight () << "; cWnd = " << m_tcb->m_cWnd);
@@ -3013,18 +3078,12 @@
       m_delAckCount = 0;
     }
 
-  // Sender should reduce the Congestion Window as a response to receiver's ECN Echo notification only once per window
   if (m_tcb->m_ecnState == TcpSocketState::ECN_ECE_RCVD && m_ecnEchoSeq.Get() > m_ecnCWRSeq.Get () && !isRetransmission)
     {
-      NS_LOG_INFO ("Backoff mechanism by reducing CWND  by half because we've received ECN Echo");
-      m_congestionControl->ReduceCwnd (m_tcb);
-      m_tcb->m_ssThresh = m_tcb->m_cWnd;
-      m_tcb->m_cWndInfl = m_tcb->m_cWnd;
-      UpdatePacingRate ();
-      flags |= TcpHeader::CWR;
-      m_ecnCWRSeq = seq;
       NS_LOG_DEBUG (TcpSocketState::EcnStateName[m_tcb->m_ecnState] << " -> ECN_CWR_SENT");
       m_tcb->m_ecnState = TcpSocketState::ECN_CWR_SENT;
+      m_ecnCWRSeq = seq;
+      flags |= TcpHeader::CWR;
       NS_LOG_INFO ("CWR flags set");
     }
 
@@ -3093,7 +3152,7 @@
   UpdateRttHistory (seq, sz, isRetransmission);
 
   // Update bytes sent during recovery phase
-  if(m_tcb->m_congState == TcpSocketState::CA_RECOVERY)
+  if (m_tcb->m_congState == TcpSocketState::CA_RECOVERY || m_tcb->m_congState == TcpSocketState::CA_CWR)
     {
       m_recoveryOps->UpdateBytesSent (sz);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-socket-base.h ns-3.33/src/internet/model/tcp-socket-base.h
--- ns-3.32/src/internet/model/tcp-socket-base.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/tcp-socket-base.h	2021-01-09 10:19:22.000000000 -0800
@@ -111,9 +111,9 @@
  * - CA_DISORDER
  * - CA_RECOVERY
  * - CA_LOSS
+ * - CA_CWR
  *
- * Another one (CA_CWR) is present but not used. For more information, see
- * the TcpCongState_t documentation.
+ * For more information, see the TcpCongState_t documentation.
  *
  * Congestion control interface
  * ---------------------------
@@ -1045,6 +1045,13 @@
   void DupAck (uint32_t currentDelivered);
 
   /**
+   * \brief Enter CA_CWR state upon receipt of an ECN Echo
+   *
+   * \param currentDelivered Currently (S)ACKed bytes
+   */
+  void EnterCwr (uint32_t currentDelivered);
+
+  /**
    * \brief Enter the CA_RECOVERY, and retransmit the head
    *
    * \param currentDelivered Currently (S)ACKed bytes
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-socket-state.h ns-3.33/src/internet/model/tcp-socket-state.h
--- ns-3.32/src/internet/model/tcp-socket-state.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/tcp-socket-state.h	2021-01-09 10:19:22.000000000 -0800
@@ -79,9 +79,9 @@
     CA_DISORDER,  /**< In all the respects it is "Open",
                     *  but requires a bit more attention. It is entered when
                     *  we see some SACKs or dupacks. It is split of "Open" */
-    CA_CWR,       /**< cWnd was reduced due to some Congestion Notification event.
-                    *  It can be ECN, ICMP source quench, local device congestion.
-                    *  Not used in NS-3 right now. */
+    CA_CWR,       /**< cWnd was reduced due to some congestion notification
+                    *  event, such as ECN, ICMP source quench, local device
+                    *  congestion. */
     CA_RECOVERY,  /**< CWND was reduced, we are fast-retransmitting. */
     CA_LOSS,      /**< CWND was reduced due to RTO timeout or SACK reneging. */
     CA_LAST_STATE /**< Used only in debug messages */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-tx-item.cc ns-3.33/src/internet/model/tcp-tx-item.cc
--- ns-3.32/src/internet/model/tcp-tx-item.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/tcp-tx-item.cc	2021-01-09 10:19:22.000000000 -0800
@@ -21,7 +21,7 @@
 namespace ns3 {
 
 void
-TcpTxItem::Print (std::ostream &os) const
+TcpTxItem::Print (std::ostream &os, Time::Unit unit /* = Time::S */) const
 {
   bool comma = false;
   os << "[" << m_startSeq << ";" << m_startSeq + GetSeqSize () << "|"
@@ -55,7 +55,7 @@
     {
       os << ",";
     }
-  os << "[" << m_lastSent.GetSeconds () << "]";
+  os << "[" << m_lastSent.As (unit) << "]";
 }
 
 uint32_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/tcp-tx-item.h ns-3.33/src/internet/model/tcp-tx-item.h
--- ns-3.32/src/internet/model/tcp-tx-item.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/tcp-tx-item.h	2021-01-09 10:19:22.000000000 -0800
@@ -37,8 +37,9 @@
   /**
    * \brief Print the time
    * \param os ostream
+   * \param unit Time::Unit
    */
-  void Print (std::ostream &os) const;
+  void Print (std::ostream &os, Time::Unit unit = Time::S) const;
 
   /**
    * \brief Get the size in the sequence number space
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/model/udp-socket-impl.cc ns-3.33/src/internet/model/udp-socket-impl.cc
--- ns-3.32/src/internet/model/udp-socket-impl.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/model/udp-socket-impl.cc	2021-01-09 10:19:22.000000000 -0800
@@ -1011,6 +1011,8 @@
     {
       Ipv4PacketInfoTag tag;
       packet->RemovePacketTag (tag);
+      tag.SetAddress (header.GetDestination ());
+      tag.SetTtl (header.GetTtl ());
       tag.SetRecvIf (incomingInterface->GetDevice ()->GetIfIndex ());
       packet->AddPacketTag (tag);
     }
@@ -1068,6 +1070,9 @@
     {
       Ipv6PacketInfoTag tag;
       packet->RemovePacketTag (tag);
+      tag.SetAddress (header.GetDestinationAddress ());
+      tag.SetHoplimit (header.GetHopLimit ());
+      tag.SetTrafficClass (header.GetTrafficClass ());
       tag.SetRecvIf (incomingInterface->GetDevice ()->GetIfIndex ());
       packet->AddPacketTag (tag);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/test/tcp-dctcp-test.cc ns-3.33/src/internet/test/tcp-dctcp-test.cc
--- ns-3.32/src/internet/test/tcp-dctcp-test.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/test/tcp-dctcp-test.cc	2021-01-09 10:19:22.000000000 -0800
@@ -29,6 +29,7 @@
 #include "tcp-error-model.h"
 #include "ns3/tcp-l4-protocol.h"
 #include "ns3/tcp-dctcp.h"
+#include "ns3/tcp-linux-reno.h"
 #include "ns3/tcp-tx-buffer.h"
 #include "ns3/config.h"
 
@@ -273,7 +274,6 @@
   if (m_tcb->m_ecnState == TcpSocketState::ECN_ECE_RCVD && m_ecnEchoSeq.Get () > m_ecnCWRSeq.Get () && !isRetransmission && m_testCase != 3)
     {
       NS_LOG_INFO ("Backoff mechanism by reducing CWND  by half because we've received ECN Echo");
-      m_congestionControl->ReduceCwnd (m_tcb);
       m_tcb->m_ssThresh = m_tcb->m_cWnd;
       flags |= TcpHeader::CWR;
       m_ecnCWRSeq = seq;
@@ -509,9 +509,9 @@
  * \ingroup internet-test
  * \ingroup tests
  *
- * \brief DCTCP should be same as NewReno during slow start
+ * \brief DCTCP should be same as Linux during slow start
  */
-class TcpDctcpToNewReno : public TestCase
+class TcpDctcpToLinuxReno : public TestCase
 {
 public:
   /**
@@ -526,7 +526,7 @@
    * \param rtt RTT
    * \param name Name of the test
    */
-  TcpDctcpToNewReno (uint32_t cWnd, uint32_t segmentSize, uint32_t ssThresh,
+  TcpDctcpToLinuxReno (uint32_t cWnd, uint32_t segmentSize, uint32_t ssThresh,
                      uint32_t segmentsAcked, SequenceNumber32 highTxMark,
                      SequenceNumber32 lastAckedSeq, Time rtt, const std::string &name);
 
@@ -546,7 +546,7 @@
   Ptr<TcpSocketState> m_state;            //!< state
 };
 
-TcpDctcpToNewReno::TcpDctcpToNewReno (uint32_t cWnd, uint32_t segmentSize, uint32_t ssThresh,
+TcpDctcpToLinuxReno::TcpDctcpToLinuxReno (uint32_t cWnd, uint32_t segmentSize, uint32_t ssThresh,
                                       uint32_t segmentsAcked, SequenceNumber32 highTxMark,
                                       SequenceNumber32 lastAckedSeq, Time rtt, const std::string &name)
   : TestCase (name),
@@ -561,15 +561,15 @@
 }
 
 void
-TcpDctcpToNewReno::DoRun ()
+TcpDctcpToLinuxReno::DoRun ()
 {
-  Simulator::Schedule (Seconds (0.0), &TcpDctcpToNewReno::ExecuteTest, this);
+  Simulator::Schedule (Seconds (0.0), &TcpDctcpToLinuxReno::ExecuteTest, this);
   Simulator::Run ();
   Simulator::Destroy ();
 }
 
 void
-TcpDctcpToNewReno::ExecuteTest ()
+TcpDctcpToLinuxReno::ExecuteTest ()
 {
   m_state = CreateObject <TcpSocketState> ();
   m_state->m_cWnd = m_cWnd;
@@ -588,96 +588,12 @@
   Ptr<TcpDctcp> cong = CreateObject <TcpDctcp> ();
   cong->IncreaseWindow (m_state, m_segmentsAcked);
 
-  Ptr<TcpNewReno> NewRenoCong = CreateObject <TcpNewReno> ();
-  NewRenoCong->IncreaseWindow (state, m_segmentsAcked);
+  Ptr<TcpLinuxReno> LinuxRenoCong = CreateObject <TcpLinuxReno> ();
+  LinuxRenoCong->IncreaseWindow (state, m_segmentsAcked);
 
   NS_TEST_ASSERT_MSG_EQ (m_state->m_cWnd.Get (), state->m_cWnd.Get (),
                          "cWnd has not updated correctly");
 }
-/**
- * \ingroup internet-test
- * \ingroup tests
- *
- * \brief Test to validate cWnd decrement DCTCP
- */
-class TcpDctcpDecrementTest : public TestCase
-{
-public:
-  /**
-   * \brief Constructor
-   *
-   * \param cWnd congestion window
-   * \param segmentSize segment size
-   * \param segmentsAcked segments acked
-   * \param highTxMark high tx mark
-   * \param lastAckedSeq last acked seq
-   * \param rtt RTT
-   * \param name Name of the test
-   */
-  TcpDctcpDecrementTest (uint32_t cWnd, uint32_t segmentSize, uint32_t segmentsAcked, SequenceNumber32 nextTxSequence,
-                         SequenceNumber32 lastAckedSeq, Time rtt, const std::string &name);
-
-private:
-  virtual void DoRun (void);
-  /** \brief Execute the test
-   */
-  void ExecuteTest (void);
-
-  uint32_t m_cWnd; //!< cWnd
-  uint32_t m_segmentSize; //!< segment size
-  uint32_t m_segmentsAcked; //!< segments acked
-  Time m_rtt; //!< rtt
-  SequenceNumber32 m_nextTxSequence; //!< next seq num to be sent
-  SequenceNumber32 m_lastAckedSeq; //!< last acked seq
-  Ptr<TcpSocketState> m_state; //!< state
-};
-
-TcpDctcpDecrementTest::TcpDctcpDecrementTest (uint32_t cWnd, uint32_t segmentSize, uint32_t segmentsAcked, SequenceNumber32 nextTxSequence,
-                                              SequenceNumber32 lastAckedSeq, Time rtt, const std::string &name)
-  : TestCase (name),
-    m_cWnd (cWnd),
-    m_segmentSize (segmentSize),
-    m_segmentsAcked (segmentsAcked),
-    m_rtt (rtt),
-    m_nextTxSequence (nextTxSequence),
-    m_lastAckedSeq (lastAckedSeq)
-{
-}
-
-void
-TcpDctcpDecrementTest::DoRun ()
-{
-  Config::SetDefault ("ns3::TcpDctcp::DctcpAlphaOnInit", DoubleValue (0));
-  Simulator::Schedule (Seconds (0.0), &TcpDctcpDecrementTest::ExecuteTest, this);
-  Simulator::Run ();
-  Simulator::Destroy ();
-}
-
-void
-TcpDctcpDecrementTest::ExecuteTest (void)
-{
-  m_state = CreateObject <TcpSocketState> ();
-  m_state->m_cWnd = m_cWnd;
-  m_state->m_segmentSize = m_segmentSize;
-  m_state->m_nextTxSequence = m_nextTxSequence;
-  m_state->m_lastAckedSeq = m_lastAckedSeq;
-
-  Ptr<TcpDctcp> cong = CreateObject <TcpDctcp> ();
-  m_state->m_ecnState = TcpSocketState::ECN_IDLE;
-  cong->PktsAcked (m_state, m_segmentsAcked, m_rtt);
-  cong->ReduceCwnd (m_state);
-  NS_TEST_ASSERT_MSG_EQ (m_state->m_cWnd.Get (), m_cWnd,
-                         "cWnd has updated correctly");
-
-  m_state->m_ecnState = TcpSocketState::ECN_ECE_RCVD;
-  cong->PktsAcked (m_state, m_segmentsAcked, m_rtt);
-  cong->ReduceCwnd (m_state);
-
-  uint32_t val = (uint32_t)(m_cWnd * (1 - 0.0625 / 2.0));
-  NS_TEST_ASSERT_MSG_EQ (m_state->m_cWnd.Get (), val,
-                         "cWnd has updated correctly");
-
-}
 
 /**
  * \ingroup internet-test
@@ -690,12 +606,11 @@
 public:
   TcpDctcpTestSuite () : TestSuite ("tcp-dctcp-test", UNIT)
   {
-    AddTestCase (new TcpDctcpToNewReno (2 * 1446, 1446, 4 * 1446, 2, SequenceNumber32 (4753), SequenceNumber32 (3216), MilliSeconds (100), "DCTCP falls to New Reno for slowstart"), TestCase::QUICK);
-    AddTestCase (new TcpDctcpDecrementTest (4 * 1446, 1446, 2, SequenceNumber32 (3216), SequenceNumber32 (4753), MilliSeconds (100), "DCTCP decrement test"), TestCase::QUICK);
+    AddTestCase (new TcpDctcpToLinuxReno (2 * 1446, 1446, 4 * 1446, 2, SequenceNumber32 (4753), SequenceNumber32 (3216), MilliSeconds (100), "DCTCP falls to New Reno for slowstart"), TestCase::QUICK);
     AddTestCase (new TcpDctcpCodePointsTest (1, "ECT Test : Check if ECT is set on Syn, Syn+Ack, Ack and Data packets for DCTCP packets"),
                  TestCase::QUICK);
     AddTestCase (new TcpDctcpCodePointsTest (2, "ECT Test : Check if ECT is not set on Syn, Syn+Ack and Ack but set on Data packets for non-DCTCP but ECN enabled traffic"),TestCase::QUICK);
-    AddTestCase (new TcpDctcpCodePointsTest (3, "ECE Functionality Test: ECE should only be sent by reciever when it receives CE flags"),
+    AddTestCase (new TcpDctcpCodePointsTest (3, "ECE Functionality Test: ECE should only be sent by receiver when it receives CE flags"),
                  TestCase::QUICK);
   }
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/test/tcp-ecn-test.cc ns-3.33/src/internet/test/tcp-ecn-test.cc
--- ns-3.32/src/internet/test/tcp-ecn-test.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/test/tcp-ecn-test.cc	2021-01-09 10:19:22.000000000 -0800
@@ -83,10 +83,10 @@
  *
  * \brief A TCP socket which sends certain data packets with CE flags set for tests 5 and 6.
  *
- * The SendDataPacket function of this class sends data packets numbered 1 and 2 with CE flags set
+ * The SendDataPacket function of this class sends data packets numbered 1 and 3 with CE flags set
  * for test 5 to verify if ECE and CWR bits are correctly set by receiver and sender respectively. It
- * also sets CE flags on data packets 10 and 11 in test case 6 to check if sender reduces congestion window
- * by half and also only once per every window.
+ * also sets CE flags on data packets 4 and 5 in test case 6 to check if sender reduces congestion window
+ * appropriately and also only once per every window.
  *
  */
 class TcpSocketCongestedRouter : public TcpSocketMsgBase
@@ -175,21 +175,11 @@
   // Sender should reduce the Congestion Window as a response to receiver's ECN Echo notification only once per window
   if (m_tcb->m_ecnState == TcpSocketState::ECN_ECE_RCVD && m_ecnEchoSeq.Get () > m_ecnCWRSeq.Get () && !isRetransmission)
     {
-      NS_LOG_INFO ("Backoff mechanism by reducing CWND  by half because we've received ECN Echo");
-      m_tcb->m_cWnd = std::max (m_tcb->m_cWnd.Get () / 2, m_tcb->m_segmentSize);
-      m_tcb->m_ssThresh = m_tcb->m_cWnd;
-      m_tcb->m_cWndInfl = m_tcb->m_cWnd;
-      flags |= TcpHeader::CWR;
-      m_ecnCWRSeq = seq;
       NS_LOG_DEBUG (TcpSocketState::EcnStateName[m_tcb->m_ecnState] << " -> ECN_CWR_SENT");
       m_tcb->m_ecnState = TcpSocketState::ECN_CWR_SENT;
+      m_ecnCWRSeq = seq;
+      flags |= TcpHeader::CWR;
       NS_LOG_INFO ("CWR flags set");
-      NS_LOG_DEBUG (TcpSocketState::TcpCongStateName[m_tcb->m_congState] << " -> CA_CWR");
-      if (m_tcb->m_congState == TcpSocketState::CA_OPEN)
-        {
-          m_congestionControl->CongestionStateSet (m_tcb, TcpSocketState::CA_CWR);
-          m_tcb->m_congState = TcpSocketState::CA_CWR;
-        }
     }
   /*
    * Add tags for each socket option.
@@ -200,11 +190,11 @@
   if (GetIpTos ())
     {
       SocketIpTosTag ipTosTag;
-      if ( m_testcase == 5 && (m_dataPacketSent == 1  || m_dataPacketSent == 2 || m_dataPacketSent == 3 || m_dataPacketSent == 4))
+      if ( m_testcase == 5 && (m_dataPacketSent == 1 || m_dataPacketSent == 3))
         {
           ipTosTag.SetTos (MarkEcnCe (GetIpTos ()));
         }
-      else if ( m_testcase == 6 &&  ( m_dataPacketSent == 10 || m_dataPacketSent == 11))
+      else if ( m_testcase == 6 &&  ( m_dataPacketSent == 4 || m_dataPacketSent == 5))
         {
           ipTosTag.SetTos (MarkEcnCe (GetIpTos ()));
         }
@@ -224,11 +214,11 @@
   else
     {
       SocketIpTosTag ipTosTag;
-      if ( m_testcase == 5 && (m_dataPacketSent == 1  || m_dataPacketSent == 2 || m_dataPacketSent == 3 || m_dataPacketSent == 4))
+      if ( m_testcase == 5 && (m_dataPacketSent == 1 || m_dataPacketSent == 3))
         {
           ipTosTag.SetTos (MarkEcnCe (GetIpTos ()));
         }
-      else if ( m_testcase == 6 && ( m_dataPacketSent == 10 || m_dataPacketSent == 11))
+      else if ( m_testcase == 6 && ( m_dataPacketSent == 4 || m_dataPacketSent == 5))
         {
           ipTosTag.SetTos (MarkEcnCe (GetIpTos ()));
         }
@@ -245,11 +235,11 @@
   if (IsManualIpv6Tclass ())
     {
       SocketIpv6TclassTag ipTclassTag;
-      if ( m_testcase == 5 && (m_dataPacketSent == 1  || m_dataPacketSent == 2 || m_dataPacketSent == 3 || m_dataPacketSent == 4))
+      if ( m_testcase == 5 && (m_dataPacketSent == 1  || m_dataPacketSent == 3))
         {
           ipTclassTag.SetTclass (MarkEcnCe (GetIpv6Tclass ()));
         }
-      else if ( m_testcase == 6 && ( m_dataPacketSent == 10 || m_dataPacketSent == 11))
+      else if ( m_testcase == 6 && ( m_dataPacketSent == 4 || m_dataPacketSent == 5))
         {
           ipTclassTag.SetTclass (MarkEcnCe (GetIpv6Tclass ()));
         }
@@ -269,11 +259,11 @@
   else
     {
       SocketIpv6TclassTag ipTclassTag;
-      if ( m_testcase == 5 && (m_dataPacketSent == 1  || m_dataPacketSent == 2 || m_dataPacketSent == 3 || m_dataPacketSent == 4))
+      if ( m_testcase == 5 && (m_dataPacketSent == 1  || m_dataPacketSent == 3))
         {
           ipTclassTag.SetTclass (MarkEcnCe (GetIpv6Tclass ()));
         }
-      else if ( m_testcase == 6 &&( m_dataPacketSent == 10 || m_dataPacketSent == 11  ))
+      else if ( m_testcase == 6 &&( m_dataPacketSent == 4 || m_dataPacketSent == 5 ))
         {
           ipTclassTag.SetTclass (MarkEcnCe (GetIpv6Tclass ()));
         }
@@ -422,7 +412,7 @@
         {
           m_cwndChangeCount++;
           NS_TEST_ASSERT_MSG_EQ (m_cwndChangeCount, 1, "Congestion window should be reduced once per every window");
-          NS_TEST_ASSERT_MSG_EQ (newValue, oldValue / 2, "Congestion window should be reduced by half");
+          NS_TEST_ASSERT_MSG_EQ (newValue, 1000, "Congestion window should not drop below 2 segments");
         }
     }
 }
@@ -468,14 +458,6 @@
               NS_TEST_ASSERT_MSG_EQ (((h.GetFlags ()) & TcpHeader::ECE), 0, "The flag ECE should not be set in the TCP header of first message received at sender when  either receiver or sender are not ECN Capable");
             }
         }
-      if (m_senderReceived == 3 && m_testcase == 5)
-        {
-          NS_TEST_ASSERT_MSG_NE (((h.GetFlags ()) & TcpHeader::ECE), 0, "The flag ECE should be set in TCP header of the packet sent by the receiver when it receives a packet with CE bit set in IP header");
-        }
-      if (m_senderReceived == 4 && m_testcase == 5)
-        {
-          NS_TEST_ASSERT_MSG_NE (((h.GetFlags ()) & TcpHeader::ECE), 0, "The flag ECE should be set in TCP header of the packet sent by the receiver even after sender sends CWR flags to receiver if it receives a packet with CE bit set in IP header");
-        }
       if ( m_testcase == 5 && m_receiverReceived > 12)
         {
           NS_TEST_ASSERT_MSG_EQ (((h.GetFlags ()) & TcpHeader::ECE), 0, "The flag ECE should not be set in TCP header of the packet sent by the receiver after sender sends CWR flags to receiver and receiver receives a packet without CE bit set in IP header");
@@ -505,9 +487,9 @@
             }
           else if (m_testcase == 5)
             {
-              if (m_senderSent == 3 || m_senderSent == 4)
+              if (m_senderSent == 3 || m_senderSent == 5)
                 {
-                  NS_TEST_ASSERT_MSG_EQ (ipTos, 0x3, "IP TOS should have CE bit set for 3rd and 4th packet sent in test case 5");
+                  NS_TEST_ASSERT_MSG_EQ (ipTos, 0x3, "IP TOS should have CE bit set for 3rd and 5th packet sent in test case 5");
                 }
               else
                 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/internet/wscript ns-3.33/src/internet/wscript
--- ns-3.32/src/internet/wscript	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/internet/wscript	2021-01-09 10:19:22.000000000 -0800
@@ -156,6 +156,7 @@
         'model/tcp-scalable.cc', 
         'model/tcp-veno.cc',
         'model/tcp-bic.cc',
+        'model/tcp-cubic.cc',
         'model/tcp-yeah.cc',
         'model/tcp-ledbat.cc',
         'model/tcp-illinois.cc',
@@ -413,6 +414,7 @@
         'model/tcp-scalable.h',
         'model/tcp-veno.h',
         'model/tcp-bic.h',
+        'model/tcp-cubic.h',
         'model/tcp-yeah.h',
         'model/tcp-illinois.h',
         'model/tcp-htcp.h',
